PROGRAM DRAGON;

USES
  Crt,Graph;

CONST
  MaxCell = 50;
  MaxDivision = 10;
  MaxDirection = 20;
  DoNothing    = 100;
  MaxLevel     = 20;

TYPE
  CellCode = Record
               Direct, Divi : Integer;
               Code         : Array[ 0..MaxCell, 0..MaxDivision ] of Integer;
               DrawDir      : Array[ 0..MaxCell ] of Integer;
             End;

VAR
  Gm,Gd,Size,
  X,Y,StartCell : Integer;
  Data          : CellCode;
  DumStr,Title  : String;
  InFile        : Text;

PROCEDURE DrawDragon( Cell,Day,X,Y,Len : Integer; Var Data : CellCode );
  VAR
    Angle    : Array[ 0..MaxDirection ] of Real;
    I        : Integer;
    Dir      : Real;

  PROCEDURE Dragon( Cell,Day : Integer );
    VAR
      I : Integer;

    BEGIN
      With Data Do
        begin
          If Cell = DoNothing Then Exit;
          If Day = 0 Then
            begin
              Cell := Drawdir[ Cell ];
              if Cell = DoNothing Then Exit;
              If Cell < Direct Then
                begin
                  Dir := Angle[ Cell ];
                  LineRel( Round( cos( Dir )*Len*(GetMaxX + 1)/640 ),
                          -Round( sin( Dir )*Len*(GetMaxY + 1)/400 ) );
                end
              Else
                begin
                  Dir := Angle[ Cell - Direct ];
                  MoveRel(  Round( cos( Dir )*Len*(GetMaxX + 1)/640 ),
                           -Round( sin( Dir )*Len*(GetMaxY + 1)/400 ) );
                end;
            end
          Else
            For I := 0 to Divi - 1 do
              begin
                Dragon( Code[ Cell,I ], Day - 1 );
              end;
        end
    END;

  BEGIN
    MoveTo( Round( X / 640 * (GetMaxX + 1) ),
            Round( Y / 400 * (GetMaxY + 1) )  );
    For I := 0 to Data.Direct - 1 do
      begin
        Angle[ I ] := I*2*Pi / Data.Direct;
      end;
    Dragon( Cell,Day );
  END;

BEGIN
  Writeln;
  Write( 'Input file name :' ); Readln( DumStr );
  Assign( InFile, DumStr+'.CEL' );
  Reset( InFile );

  Gd := Detect;
  InitGraph( Gd,Gm,'' );

  While not EOF( InFile ) do
    begin

      Readln( InFile,Title );

      With Data do
        begin
          Readln( InFile,Direct,Divi );
          Gd := 0;
          Repeat
            For Gm := 0 to Divi - 1 do
              Read( InFile,Code[ Gd,Gm ] );
            Read( InFile,DrawDir[ Gd ] );
            Readln( InFile,DumStr );
            Gd := Gd + 1;
          Until DumStr = ' END';
        end;
      Gm := 1;
      Readln( InFile,StartCell );
      Readln( InFile,Gm,X,Y,Size );
      Repeat
        Str( Gm,DumStr );
        OutTextXY( 0,0, 'Level '+DumStr );
        OutTextXY( 0,8, Title );
        DrawDragon( StartCell,Gm,X,Y,Size,Data );
        Readln;
        ClearDevice;
        Readln( InFile,Gm,X,Y,Size );
      Until X <= -1;

    end;

  CloseGraph;

END.