PROGRAM JULIA_SETS;

USES
  Graph;

LABEL
  1,2;

CONST
  MaxCount = 100;

VAR
  Xmax, Xmin, Ymax, Ymin,
  Zx,Zy, Cx,Cy, Za,Zb,
  dX,dY,b1,r             : Real;
  Ix,Iy,k,Color,Size,
  Gd,Gm                  : Integer;
  Ch                     : Char;
  Cont                   : Boolean;
  Dum1,Dum2              : String[10];

BEGIN

  Randomize;

  Cont := FALSE;

1:

  Write ( 'X : min - ' ); Readln( Xmin );
  Write ( '    max - ' ); Readln( Xmax );
  Write ( 'Y : min - ' ); Readln( Ymin );
  Ymax := Ymin + Xmax - Xmin;
  Write ( 'Size : ' );    Readln( Size );

  Gd := Detect;
  InitGraph ( Gd,Gm,'' );

2:

  Cx := 1.0 - Random(200) / 100; Cy := 1.0 - Random(200) / 100;
  dX := ( Xmax - Xmin ) / ( Size - 1 );
  dY := ( Ymax - Ymin ) / ( Size - 1 );

  OutTextXY( GetMaxX - 150,0, '** Julia Set **' );
  SetColor( White );
  Rectangle( 0,0, Size+1,Size+1 );

  SetFillStyle( EmptyFill,Black );
  Bar( GetMaxX - 200,20, GetMaxX, 250 );
  Str( Xmin:5,Dum1 );
  Str( Xmax:5,Dum2 );
  OutTextXY( GetMaxX - 100,20,'X :' + Dum1 );
  OutTextXY( GetMaxX - 100,40,' ->' + Dum2 );
  Str( Ymin:5,Dum1 );
  Str( Ymax:5,Dum2 );
  OutTextXY( GetMaxX - 100,70,'Y :' + Dum1 );
  OutTextXY( GetMaxX - 100,90,' ->' + Dum2 );
  Str( Cx:5,Dum1 );
  Str( Cy:5,Dum2 );
  OutTextXY( GetMaxX - 200,120,'C = ' + Dum1 + ' + i' + Dum2 );

  Zx := Xmin;   Zy := Ymin;

  For Iy := 1 to Size do
    begin
      For Ix := 1 to Size do
        begin

          k := 0;
          Za := Zx;
          Zb := Zy;

          Repeat
            b1 := 2*Za*Zb;
            Za := Za*Za - Zb*Zb + Cx;
            Zb := b1 + Cy;
            k  := k + 1;
            r  := Za*Za + Zb*Zb;
          Until ( r > MaxCount ) or ( k = GetMaxColor );

          If r > MaxCount Then
            Color := k
          Else if k = GetMaxColor Then
            Color := 0;

          PutPixel( Ix,Iy,Color );

          Zx := Zx + dX;

        end;

      Zx := Xmin;
      Zy := Zy + dY;

    end;

  If Cont Then Goto 2;
  Readln;

  CloseGraph;

  Write( 'Again? (Y/N)' );
  Readln( Ch );
  If UpCase( Ch ) = 'Y' Then Goto 1;
  If UpCase( Ch ) = 'C' Then
    begin
      Cont := TRUE;
      Gd := Detect;
      InitGraph ( Gd,Gm,'' );
      Goto 2;
    end;

END.
