USES
  Graph;

CONST
  Size = 50;

TYPE
  ListPointer = ^ListRecord;
  ListRecord = Record
                 Data  : Char;
                 Link  : ListPointer;
               End;
  BranchRec = Record
                X,Y,Dir,DirInc : Integer;
              End;
  StackPointer = ^StackRecord;
  StackRecord  = Record
                   Data : BranchRec;
                   Next : StackPointer;
                 End;

VAR
  List : ListPointer;
  StackTop : StackPointer;
  Branch : BranchRec;
  I    : Integer;

PROCEDURE MakeL ( l : ListPointer );
VAR
  Next,D2,D3 : ListPointer;

BEGIN
  While l <> nil Do
    begin
      Next := l^.Link;
      If l^.Data = '0' Then
        begin
          l^.Data := '1';
          New( D2 );
          D2^.Data := '[';
          l^.Link := D2;
          D3 := D2;
          New( D2 );
          D2^.Data := '0';
          D3^.Link := D2;
          D3 := D2;
          New( D2 );
          D2^.Data := ']';
          D3^.Link := D2;
          D3 := D2;
          New( D2 );
          D2^.Data := '0';
          D3^.Link := D2;
          D2^.Link := Next;
        end;
      l := Next;
    end;
END;

PROCEDURE Push( Data : BranchRec );
VAR
  D : StackPointer;

BEGIN
  New( D );
  D^.Next := StackTop;
  D^.Data := Data;
  StackTop := D;
END;

PROCEDURE Pop( Var Data : BranchRec );
VAR
  D : StackPointer;

BEGIN
  Data := Stacktop^.Data;
  D := StackTop;
  StackTop := StackTop^.Next;
  Dispose( D );
END;

PROCEDURE DrawL ( l : ListPointer );
VAR
  Dir,DirInc : Integer;

BEGIN
  SetLineStyle( SolidLn,0,ThickWidth );
  Dir := 2;
  DirInc := -1;
  MoveTo( GetMaxX div 2,GetMaxY - 50 );
  While l <> nil Do
    begin
      Case l^.Data Of
        '1' : LineRel( Round( Size*cos( pi/4*Dir ) ),
                      -Round( Size*sin( pi/4*Dir ) ) );
        '0' : LineRel( Round( Size*cos( pi/4*Dir )/2 ),
                      -Round( Size*sin( pi/4*Dir )/2 ) );
        '[' : begin
                Branch.X := GetX;
                Branch.Y := GetY;
                Branch.Dir := Dir;
                Branch.DirInc := DirInc;
                Push( Branch );
                Dir := Dir + DirInc;
                If Dir < 0 Then Dir := 7;
                If Dir > 7 Then Dir := 0;
              end;
        ']' : begin
                Pop( Branch );
                MoveTo( Branch.X,Branch.Y );
                Dir := Branch.Dir;
                DirInc := -Branch.DirInc;
              end;
      end;
      l := l^.Link;
    end;
END;

BEGIN

  I := Detect;
  InitGraph ( I,I,'' );

  New( List );
  List^.Data := '0';
  List^.Link := nil;
  StackTop := nil;

  For I := 1 to 5 do
    begin
      MakeL ( List );
      DrawL ( List );
      Readln;
    end;

  CloseGraph;

END.
