PROGRAM MANDELBROT_SET;

USES
  Crt,Graph;

CONST
  StopRange = 100;
  MaxColor = 50;

VAR
  Gd,Gm,ScreenSize,
  Ix,Iy,Color,k        : Integer;
  Xmin,Xmax,Ymin,Ymax,
  Za,Zb,p ,q ,b1,
  dX,dY,r              : Real;

BEGIN

  Gd := Detect;
  InitGraph ( Gd,Gm,'' );

  ScreenSize := 300;

  Xmin := -2.25; Xmax := 0.75;
  Ymin := -1.5;  Ymax := 1.5;

  dX := ( Xmax - Xmin ) / ( ScreenSize - 1 );
  dY := ( Ymax - Ymin ) / ( ScreenSize - 1 );

  p := Xmin;
  q := Ymin;

  For Iy := 1 to ScreenSize do
    begin
      For Ix := 1 to ScreenSize do
          begin
            k  := 0;
            Za := p;
            Zb := q;
            Repeat
              b1 := 2*Za*Zb;
              Za := Za*Za - Zb*Zb + p;
              Zb := b1 + q;
              r := Za*Za + Zb*Zb;
              k := k + 1;
            Until ( r > StopRange ) or ( k > MaxColor );

            If r > StopRange Then
              Color := k mod (GetMaxColor+1)
            Else
              Color := Black;

            PutPixel ( Ix, Iy, Color );

            p := p + dX;
          end;
        q := q + dY;
        p := Xmin;
      end;

  Readln;

  CloseGraph;

END.

