PROGRAM MANDELBLOT_SETS;

USES
  Crt,Graph;

CONST
  StopRange = 100;
  Size      = 400;

VAR
  Xmax, Xmin, Ymax, Ymin,
  Zx,Zy, Cx,Cy, Za,Zb,
  dX,dY,b1,r              : Real;
  Ix,Iy,k,Color,
  MaxCount                : Integer;
  Stop                    : Boolean;

PROCEDURE OutTextE( X,Y : Integer; Msg : String );
  Begin
    SetFillStyle( EmptyFill,Black );
    Bar( X,Y, X+TextWidth( Msg ),Y+TextHeight( Msg ) );
    OutTextXY( X,Y,Msg );
  End;

PROCEDURE PutPanel;
  Var
    Dum1,Dum2 : String;

  Begin
    Str( Xmin,Dum1 );
    Str( Xmax,Dum2 );
    OutTextE( GetMaxX - 200,20,'X :' + Dum1 );
    OutTextE( GetMaxX - 200,40,'   ' + Dum2 );
    Str( Ymin,Dum1 );
    Str( Ymax,Dum2 );
    OutTextE( GetMaxX - 200,70,'Y :' + Dum1 );
    OutTextE( GetMaxX - 200,90,'   ' + Dum2 );
    Str( MaxCount:8,Dum1 );
    OutTextE( GetMaxX - 200,120,'No of Iters. :'+Dum1 );

  End;


PROCEDURE PutTitle;
  Var
    Gd,Gm : Integer;

  Begin
    Gd := Detect;
    InitGraph( Gd,Gm, '' );

    ClearViewPort;

    OutTextXY( GetMaxX - 200,0, '** Mandelbrot Set **' );
    SetColor( White );
    Rectangle( 0,0, Size+1,Size+1 );
  End;

PROCEDURE GetNewBd;
  Var
    PXmin,PYmin          : Real;
    CurX,CurY,CurSize    : Integer;
    Ch                   : Char;

  Begin
    CurX := 1; CurY := 1; CurSize := 50;

    SetColor( White );
    SetWriteMode( XORput );
    Rectangle( CurX,CurY,
               CurX+CurSize, CurY+CurSize );

    PXmin := Xmin;    PYmin := Ymin;
    Repeat
      Ch := ReadKey;
      Rectangle( CurX,CurY,
                 CurX+CurSize, CurY+CurSize );
      If Ch = #0 Then
        Case ReadKey of
          #72 : CurY := CurY - 5;
          #75 : CurX := CurX - 5;
          #77 : CurX := CurX + 5;
          #80 : CurY := CurY + 5;
          #59 : CurSize := CurSize + 5;
          #60 : If CurSize > 5 Then CurSize := CurSize - 5;
          #61 : MaxCount := MaxCount + 100;
          #62 : begin
                  MaxCount := MaxCount - 100;
                  If MaxCount < GetMaxColor Then MaxCount := GetMaxColor;
                end;
        End
      Else If Ch = #9 Then
        CurSize := CurSize + 10
      Else If Ch = #27 Then
        begin
          Stop := TRUE;
          Exit;
        end;

      Rectangle( CurX,CurY,
                 CurX+CurSize, CurY+CurSize );
      Xmin := PXmin + (CurX-1)*dX;
      Xmax := PXmin + (CurX-1+CurSize)*dX;
      Ymin := PYmin + (CurY-1)*dY;
      Ymax := Ymin + Xmax - Xmin;
      PutPanel;
    Until Ch = #13;
  End;

BEGIN

  Write ( 'X - min : ' ); Readln( Xmin );
  Write ( '    max : ' ); Readln( Xmax );
  Write ( 'Y - min : ' ); Readln( Ymin );
  Ymax := Ymin + Xmax - Xmin;
  Write ( 'No of iterations : ' ); Readln( MaxCount );

  Stop := FALSE;

  PutTitle;
  If MaxCount < GetMaxColor Then MaxCount := GetMaxColor;

  Repeat

    PutPanel;

    dX := ( Xmax - Xmin ) / ( Size - 1 );
    dY := ( Ymax - Ymin ) / ( Size - 1 );

    Zx := Xmin;   Zy := Ymin;

    For Iy := 1 to Size do
      begin

        For Ix := 1 to Size do
          begin

            k := 0;
            Za := 0;
            Zb := 0;
            Cx := Zx;
            Cy := Zy;

            Repeat
              b1 := 2*Za*Zb;
              Za := Za*Za - Zb*Zb + Cx;
              Zb := b1 + Cy;
              k  := k + 1;
              r  := Za*Za + Zb*Zb;
            Until ( r > StopRange ) or ( k = MaxCount );

            If r > StopRange Then
              Color := k mod GetMaxColor
            Else if k = MaxCount Then
              Color := 0;

            PutPixel( Ix,Iy,Color );

            Zx := Zx + dX;

          end;

        Zx := Xmin;
        Zy := Zy + dY;
        If KeyPressed Then Iy := Size;

      end;

    GetNewBd;

  Until Stop;

END.
